Package biotransformer.btransformers

## Class Phase2BTransformer

- java.lang.Object
- - biotransformer.btransformers.Biotransformer
  - - biotransformer.btransformers.Phase2BTransformer

    public class Phase2BTransformer
    extends Biotransformer

Author:
  Yannick Djoumbou Feunang

### Field Summary

### Fields inherited from class biotransformer.btransformers.Biotransformer

`bSystem, enzymesByreactionGroups, enzymesList, inchiGenFactory, mapper, reactionsByGroups, reactionsHash, smiGen`

### Constructor Summary

Constructors
`Phase2BTransformer​(BioSystem.BioSystemName bioSName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`java.util.ArrayList<Biotransformation>` `applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean precheck, boolean preprocess, boolean filter)`
`java.util.ArrayList<Biotransformation>` `applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean precheck, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean precheck, boolean preprocess, boolean filter, double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean precheck, boolean preprocess, boolean filter, int nr_of_steps)`
`java.util.ArrayList<Biotransformation>` `applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target, boolean precheck, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainerSet targets, boolean precheck, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`java.util.ArrayList<Biotransformation>` `applyReactionAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target, MetabolicReaction reaction, boolean preprocess, java.lang.Double scoreThreshold)`
`void` `applyReactionChainFromSDF​(java.lang.String inputFileName, boolean precheck, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold)`
`void` `applyReactionChainFromSdfToSingleSdf​(java.lang.String inputFileName, boolean precheck, boolean preprocess, boolean filter, int nr_of_steps, java.lang.Double scoreThreshold, java.lang.String outputFileName, boolean annotate)`
`java.util.ArrayList<Biotransformation>` `applyReactionsAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target, java.util.ArrayList<MetabolicReaction> reactions, boolean preprocess, boolean filter, java.lang.Double scoreThreshold)`
`boolean` `isPotentialHumanPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)`
`boolean` `isPotentialNonHumanPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)`
`boolean` `isPotentialPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)`
`void` `printStatistics()`
`org.openscience.cdk.interfaces.IAtomContainerSet` `reduceSet​(org.openscience.cdk.interfaces.IAtomContainerSet molecules)`
`java.util.ArrayList<Biotransformation>` `selectBiotransformationWithValidProducts​(java.util.ArrayList<Biotransformation> biotransformations)`

### Methods inherited from class biotransformer.btransformers.Biotransformer

`applyPathwaySpecificBiotransformationChain, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformations, applyPathwaySpecificBiotransformationsChain, applyPathwaySpecificBiotransformationsChain, applyReactionAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionAtOnceAndReturnBiotransformations, applyReactionChain, applyReactionChain, applyReactions, applyReactions, applyReactionsAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsChainAndReturnBiotransformations, applyReactionsFromContainersAndReturnBiotransformations, extractProductsFromBiotransformations, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, extractProductsFromBiotransformationsWithTransformationData, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainer, generateAllMetabolitesFromAtomContainerViaTransformationAtAllLocations, getBioSystemName, getReactionsList, getSmiParser, isValidSubstrate, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzyme, metabolizeWithEnzymes, metabolizeWithEnzymes, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesBreadthFirst, metabolizeWithEnzymesDephtFirst, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToCSV, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSdf, saveBioTransformationProductsToSDF`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Phase2BTransformer

    public Phase2BTransformer​(BioSystem.BioSystemName bioSName)
                       throws java.io.IOException,
                              org.json.simple.parser.ParseException,
                              org.openscience.cdk.exception.CDKException

Throws:
  `java.io.IOException`
  `org.json.simple.parser.ParseException`
  `org.openscience.cdk.exception.CDKException`

### Method Detail

#### applyPhase2Transformations

    public java.util.ArrayList<Biotransformation> applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                             boolean precheck,
                                                                             boolean preprocess,
                                                                             boolean filter)
                                                                      throws java.lang.Exception

Parameters:
  `target` -
  `preprocess` -
  `filter` -
Returns:
  an arraylist of biotransformations, which are instances of the Phase II metabolic reactions applied to the target, with the set minimum threshold of 0.0
Throws:
  `java.lang.Exception`

#### applyPhase2Transformations

    public java.util.ArrayList<Biotransformation> applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                             boolean precheck,
                                                                             boolean preprocess,
                                                                             boolean filter,
                                                                             double scoreThreshold)
                                                                      throws java.lang.Exception

Parameters:
  `target` -
  `preprocess` -
  `filter` -
  `scoreThreshold` -
Returns:
  an arraylist of biotransformations, which are instances of the Phase II metabolic reactions applied to the target, with the set minimum threshold
Throws:
  `java.lang.Exception`

#### applyPhase2Transformations

    public java.util.ArrayList<Biotransformation> applyPhase2Transformations​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                             boolean precheck,
                                                                             boolean preprocess,
                                                                             boolean filter,
                                                                             double scoreThreshold)
                                                                      throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyPhase2TransformationsChainAndReturnBiotransformations

    public java.util.ArrayList<Biotransformation> applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                                             boolean precheck,
                                                                                                             boolean preprocess,
                                                                                                             boolean filter,
                                                                                                             int nr_of_steps)
                                                                                                      throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyPhase2TransformationsChainAndReturnBiotransformations

    public java.util.ArrayList<Biotransformation> applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                                             boolean precheck,
                                                                                                             boolean preprocess,
                                                                                                             boolean filter,
                                                                                                             int nr_of_steps,
                                                                                                             java.lang.Double scoreThreshold)
                                                                                                      throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyPhase2TransformationsChainAndReturnBiotransformations

    public java.util.ArrayList<Biotransformation> applyPhase2TransformationsChainAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainerSet targets,
                                                                                                             boolean precheck,
                                                                                                             boolean preprocess,
                                                                                                             boolean filter,
                                                                                                             int nr_of_steps,
                                                                                                             java.lang.Double scoreThreshold)
                                                                                                      throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyReactionAndReturnBiotransformations

    public java.util.ArrayList<Biotransformation> applyReactionAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                           MetabolicReaction reaction,
                                                                                           boolean preprocess,
                                                                                           java.lang.Double scoreThreshold)
                                                                                    throws java.lang.Exception

Overrides:
  `applyReactionAndReturnBiotransformations` in class `Biotransformer`
Throws:
  `java.lang.Exception`

#### applyReactionsAndReturnBiotransformations

    public java.util.ArrayList<Biotransformation> applyReactionsAndReturnBiotransformations​(org.openscience.cdk.interfaces.IAtomContainer target,
                                                                                            java.util.ArrayList<MetabolicReaction> reactions,
                                                                                            boolean preprocess,
                                                                                            boolean filter,
                                                                                            java.lang.Double scoreThreshold)
                                                                                     throws java.lang.Exception

Overrides:
  `applyReactionsAndReturnBiotransformations` in class `Biotransformer`
Throws:
  `java.lang.Exception`

#### applyReactionChainFromSDF

    public void applyReactionChainFromSDF​(java.lang.String inputFileName,
                                          boolean precheck,
                                          boolean preprocess,
                                          boolean filter,
                                          int nr_of_steps,
                                          java.lang.Double scoreThreshold)
                                   throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### applyReactionChainFromSdfToSingleSdf

    public void applyReactionChainFromSdfToSingleSdf​(java.lang.String inputFileName,
                                                     boolean precheck,
                                                     boolean preprocess,
                                                     boolean filter,
                                                     int nr_of_steps,
                                                     java.lang.Double scoreThreshold,
                                                     java.lang.String outputFileName,
                                                     boolean annotate)
                                              throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### isPotentialHumanPhase2SubstrateByReactionPatternMatching

    public boolean isPotentialHumanPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)
                                                                     throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### isPotentialNonHumanPhase2SubstrateByReactionPatternMatching

    public boolean isPotentialNonHumanPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)
                                                                        throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### isPotentialPhase2SubstrateByReactionPatternMatching

    public boolean isPotentialPhase2SubstrateByReactionPatternMatching​(org.openscience.cdk.interfaces.IAtomContainer substrate)
                                                                throws java.lang.Exception

Throws:
  `java.lang.Exception`

#### reduceSet

    public org.openscience.cdk.interfaces.IAtomContainerSet reduceSet​(org.openscience.cdk.interfaces.IAtomContainerSet molecules)
                                                               throws org.openscience.cdk.exception.CDKException,
                                                                      java.lang.Exception

Throws:
  `org.openscience.cdk.exception.CDKException`
  `java.lang.Exception`

#### selectBiotransformationWithValidProducts

    public java.util.ArrayList<Biotransformation> selectBiotransformationWithValidProducts​(java.util.ArrayList<Biotransformation> biotransformations)
                                                                                    throws ambit2.smarts.query.SMARTSException,
                                                                                           org.openscience.cdk.exception.CDKException,
                                                                                           java.lang.CloneNotSupportedException

Throws:
  `ambit2.smarts.query.SMARTSException`
  `org.openscience.cdk.exception.CDKException`
  `java.lang.CloneNotSupportedException`

#### printStatistics

    public void printStatistics()